import type * as functions from 'firebase-functions';
import { type Crypter } from './crypter';
import { type DatabaseType } from './DatabaseType';
import { type FirebaseFunctionType as _FirebaseFunctionType } from './FirebaseFunction';
import { type FunctionType as _FunctionType } from './FunctionType';
import { type ValidReturnType } from './ValidReturnType';
export type FirebaseFunctionDescriptor<__FirebaseFunctionType extends _FirebaseFunctionType<_FunctionType<unknown, ValidReturnType, unknown>>, __FunctionType extends _FunctionType<unknown, ValidReturnType, unknown>> = () => __FirebaseFunctionType;
export declare namespace FirebaseFunctionDescriptor {
    type FirebaseFunctionType<T extends FirebaseFunctionDescriptor<_FirebaseFunctionType<_FunctionType<unknown, ValidReturnType, unknown>>, _FunctionType<unknown, ValidReturnType, unknown>>> = T extends FirebaseFunctionDescriptor<infer __FirebaseFunctionType, _FunctionType<unknown, ValidReturnType, unknown>> ? __FirebaseFunctionType : never;
    type FunctionType<T extends FirebaseFunctionDescriptor<_FirebaseFunctionType<_FunctionType<unknown, ValidReturnType, unknown>>, _FunctionType<unknown, ValidReturnType, unknown>>> = T extends FirebaseFunctionDescriptor<_FirebaseFunctionType<_FunctionType<unknown, ValidReturnType, unknown>>, infer __FunctionType> ? __FunctionType : never;
    function create<__FirebaseFunctionType extends _FirebaseFunctionType<_FunctionType<unknown, ValidReturnType, unknown>>, __FunctionType extends _FunctionType<unknown, ValidReturnType, unknown>>(firebaseFunctions: __FirebaseFunctionType): FirebaseFunctionDescriptor<__FirebaseFunctionType, __FunctionType>;
}
export type FirebaseFunctionsType = FirebaseFunctionDescriptor<_FirebaseFunctionType<_FunctionType<unknown, ValidReturnType, unknown>>, _FunctionType<unknown, ValidReturnType, unknown>> | {
    [key: string]: FirebaseFunctionsType;
};
export type FirebaseRunnableFunctions = (functions.HttpsFunction & functions.Runnable<unknown>) | {
    [key: string]: FirebaseRunnableFunctions;
};
export declare function createFirebaseFunctions(firebaseFunctions: FirebaseFunctionsType, getCryptionKeys: (databaseType: DatabaseType) => Crypter.Keys, getCallSecretKey: (databaseType: DatabaseType) => string): FirebaseRunnableFunctions;
