"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createFirebaseFunctions = exports.FirebaseFunctionDescriptor = void 0;
const FirebaseFunction_1 = require("./FirebaseFunction");
var FirebaseFunctionDescriptor;
(function (FirebaseFunctionDescriptor) {
    function create(firebaseFunctions) {
        return () => {
            return firebaseFunctions;
        };
    }
    FirebaseFunctionDescriptor.create = create;
})(FirebaseFunctionDescriptor = exports.FirebaseFunctionDescriptor || (exports.FirebaseFunctionDescriptor = {}));
function createFirebaseFunctions(firebaseFunctions, getCryptionKeys, getCallSecretKey) {
    if (typeof firebaseFunctions === 'function')
        return FirebaseFunction_1.FirebaseFunction.create(firebaseFunctions(), getCryptionKeys, getCallSecretKey);
    const firebaseRunnableFunctions = {};
    for (const entry of Object.entries(firebaseFunctions))
        firebaseRunnableFunctions[entry[0]] = createFirebaseFunctions(entry[1], getCryptionKeys, getCallSecretKey);
    return firebaseRunnableFunctions;
}
exports.createFirebaseFunctions = createFirebaseFunctions;
