import { type ILogger } from './ILogger';
import { LogLevel } from './LogLevel';
import { type VerboseType } from './VerboseType';
export declare class Logger implements ILogger {
    private readonly verbose;
    private readonly properties;
    private readonly currentIndent;
    private constructor();
    static start(verbose: VerboseType, functionName: string, details?: Record<string, unknown>, logLevel?: LogLevel): ILogger;
    get nextIndent(): ILogger;
    log(functionName: string, details?: Record<string, unknown>, logLevel?: LogLevel): void;
    private propertyString;
    private detailString;
    get completeLog(): string;
}
