import { Crypter } from '../crypter/Crypter';
import { type DatabaseType } from '../DatabaseType';
import { type ILogger } from '../logger';
import { type ParameterBuilder } from './ParameterBuilder';
import { type TypeOfName } from './TypeOf';
export declare class ParameterContainer {
    private readonly data;
    readonly databaseType: DatabaseType;
    constructor(data: Record<PropertyKey, unknown> & {
        databaseType: DatabaseType;
    }, getCryptionKeys: (databaseType: DatabaseType) => Crypter.Keys, logger: ILogger);
    optionalParameter<TypeName extends TypeOfName, T>(key: PropertyKey, builder: ParameterBuilder<TypeName, T>, logger: ILogger): T | undefined;
    parameter<TypeName extends TypeOfName, T>(key: PropertyKey, builder: ParameterBuilder<TypeName, T>, logger: ILogger): T;
}
