import { type Crypter } from '../crypter';
import { type FirebaseOptions } from 'firebase/app';
import { FirebaseFunctions } from './FirebaseFunctions';
import { FirebaseDatabase } from './FirebaseDatabase';
import { FirebaseAuth } from './FirebaseAuth';
import { type SchemeType } from '../database';
import { type FirebaseFunctionsType } from '../FirebaseFunctionsType';
export declare class FirebaseApp<FFunctions extends FirebaseFunctionsType, DatabaseScheme extends SchemeType> {
    private readonly cryptionKeys;
    private readonly callSecretKey;
    private readonly _functions;
    private readonly _database;
    private readonly _auth;
    constructor(options: FirebaseOptions, cryptionKeys: Crypter.Keys, callSecretKey: string, config?: FirebaseApp.Config);
    get functions(): FirebaseFunctions<FFunctions>;
    get database(): FirebaseDatabase<DatabaseScheme>;
    get auth(): FirebaseAuth;
}
export declare namespace FirebaseApp {
    interface Config {
        name?: string;
        functionsRegion?: string;
        databaseUrl?: string;
    }
}
