"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.FirebaseAuth = void 0;
const auth_1 = require("firebase/auth");
class FirebaseAuth {
    auth;
    constructor(auth) {
        this.auth = auth;
    }
    get currentUser() {
        return this.auth.currentUser;
    }
    async signIn(email, password) {
        return await (0, auth_1.signInWithEmailAndPassword)(this.auth, email, password);
    }
    async signOut() {
        if (this.currentUser !== null)
            await (0, auth_1.signOut)(this.auth);
    }
}
exports.FirebaseAuth = FirebaseAuth;
